`timescale 1ns/1ps

module tb;

reg masterClk =0;
reg slaveClk =0;

reg [4:1] mKey =4'hf;
reg [4:1] sKey =4'hf;

wire mLock, sLock;
wire linkDone;

initial begin
    while( !(mLock & sLock) )begin
        #1;
    end
    

    sKey[1] <= 0;
    #30_000;
    sKey[1] <= 1;

    sKey[2] <= 0;
    #60_000;
    sKey[2] <= 1;
    #10_000;
    #100;
    mKey[1] <= 0;
    #30_000;
    mKey[1] <= 1;
    
    mKey[2] <= 0;
    #60_000;
    mKey[2] <= 1;
    #100;

       #1000_000;
	$finish;
end


always #10 masterClk <= !masterClk;
always #10 slaveClk <= !slaveClk;


reg gstn =0;
GSR GSR(.GSRI(gstn));
initial begin
    $fsdbDumpfile("i3c.fsdb");
    $fsdbDumpvars;
    #10;
    gstn = 1;
end

wire SDA, SCL;
wire mSDA;
wire sSDA;

tran  m2b(SDA,mSDA);
tran  s2b(SDA,sSDA);

    pullup  ipUpSDA(SDA);
    pullup  ipUpSCL(SCL);
    topM master(
        .clk_in(masterClk),
        .key_1(mKey[1]),
        .key_2(mKey[2]),
        .key_3(mKey[3]),
        .key_4(mKey[4]),
        .j8_3(mLock),
        .j10_1(mSDA),
        .j10_5(SCL),
        .j8_5(linkDone)
    );

    topS slave(
        .clk_in(slaveClk),
        .key_1(sKey[1]),
        .key_2(sKey[2]),
        .key_3(sKey[3]),
        .key_4(sKey[4]),
        .j8_3(sLock),
        .j10_1(sSDA),
        .j10_5(SCL)
    );


endmodule