module deJitter(
    output keyPos_o,//deJitter posedge key value
	output keyNeg_o,//deJitter negedge key value
	output key_o,	//deJitter key value
    input 	key_i,
    input 	clk_i
);


parameter	alwaysState = 1'b1;

localparam  keyInINI    = alwaysState * 4'hf;
localparam  keyValueINI = alwaysState * 2'b11;

reg [7:0] 	counter         = 0;
reg 		cntOverDly		= 0;
reg			keyPos			= 0;
reg			keyNeg			= 0;
reg         keyO            = alwaysState;
reg	[2:0]	keyIn_r			= keyInINI;
reg	[1:0]	keyValue		= keyValueINI;
wire 		pp;
wire 		cntOver 		= &counter;
wire		cntOverPos		= cntOver & (!cntOverDly);


assign pp		= keyIn_r[2]^keyIn_r[1]; 
assign key_o	= keyO;
assign keyPos_o	= keyPos;
assign keyNeg_o	= keyNeg;

always@(posedge clk_i) begin
	keyIn_r <= {keyIn_r[1:0],key_i};
end

always@(posedge clk_i) begin
	if(pp)
		counter <= 8'd0;
	else
		counter <= counter + 1;
end
always@(posedge clk_i) begin
    if(cntOverPos)
        keyO <= keyIn_r[1];
end

always@(posedge clk_i) begin
	keyValue <= {keyValue,keyO};
end

always@(posedge clk_i) begin
	case(keyValue)
		2'b00:begin
			keyPos <= 1'b0;
			keyNeg <= 1'b0;
		end
		2'b11:begin
			keyPos <= 1'b0;
			keyNeg <= 1'b0;
		end
		2'b01:begin
			keyPos <= 1'b1;
			keyNeg <= 1'b0;
		end
		2'b10:begin
			keyPos <= 1'b0;
			keyNeg <= 1'b1;
		end
	endcase
end

endmodule
